; 
    .686                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    .XMM
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\msvcrt.lib

    include \masm32\macros\macros.asm
    include timers.asm
StrLen2 PROTO :DWORD ; Agner Fog's high speed string length algo
mmxlen PROTO :DWORD
; 
    .data
    align 16
    str1 db 9999 dup(48), 0

    result dd 0

    align 16
    zero dq 0
    .code
; 
start: 
; 

    print chr$("Agner Fog's : ")
    counter_begin 100000, HIGH_PRIORITY_CLASS
      invoke StrLen2, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles resulting in : ")
    print ustr$(result)
    print chr$(13, 10)

    print chr$("MMX strlen  : ")
    counter_begin 100000, HIGH_PRIORITY_CLASS
      invoke mmxlen, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles resulting in : ")
    print ustr$(result)
    print chr$(13, 10)
    
    ;; mov   eax, input(13,10,"Press enter to exit...")

    inkey

    exit

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

StrLen2 proc item:DWORD

    push ebx
    push esi
    push edi

    mov esi, 80808080h
    mov edi, 00008080h

    mov     eax,[esp+16]           ; get pointer to string
    lea     edx,[eax+3]            ; pointer+3 used in the end

  align 4
  @@: 
  REPEAT 3
    mov     ebx,[eax]              ; read first 4 bytes
    add     eax,4                  ; increment pointer
    lea     ecx,[ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                    ; invert all bytes
    and     ecx,ebx                ; and these two
    and     ecx,esi
    jnz     ilbl
  ENDM
    mov     ebx,[eax]              ; read first 4 bytes
    add     eax,4                  ; increment pointer
    lea     ecx,[ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                    ; invert all bytes
    and     ecx,ebx                ; and these two
    and     ecx,esi
    jz      @B                     ; no zero bytes, continue loop

  ilbl:
    test    ecx, edi               ; test first two bytes
    jnz     @F
    shr     ecx,16                 ; not in the first 2 bytes
    add     eax,2
  @@:
    shl     cl,1                   ; use carry flag to avoid branch
    sbb     eax,edx                ; compute length

    pop edi
    pop esi
    pop ebx

    mov result, eax                ; save result

    ret     4

StrLen2 endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

align 16
nop
nop
nop
mmxlen proc item:DWORD
    mov edx, item
    xor eax, eax
    mov ecx, offset zero
    @@:
    movq MM0, [edx]
    pcmpeqb MM0, [ecx]
    pmovmskb EAX, MM0
    add edx, 8
    test eax, eax
    jz @B
    bsf ecx, eax
    lea eax, [ecx+edx-8]
    sub eax, item
    mov result, eax
    ret
mmxlen endp
end start
